package com.xjrsoft.module.oa.dto;

import com.xjrsoft.common.page.PageInput;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import javax.validation.constraints.Min;
import javax.validation.constraints.NotNull;

/**
 * @Author: tzx
 * @Date: 2022/6/27 15:38
 */
@Data
@EqualsAndHashCode(callSuper = false)
public class NewsPageDto extends PageInput {

    @ApiModelProperty(value = "类型（1-新闻2-公告）")
    @NotNull(message = "类型不能为空！")
    @Min(value = 1, message = "类型必须大于0")
    private Integer type;

    @ApiModelProperty("班级(base_class)")
    private Long classId;

    @ApiModelProperty("级别 1=校级 2=班级")
    private Integer level;

    /**
     * 作者
     */
    @ApiModelProperty("作者")
    private String authorName;

    /**
     * 完整标题
     */
    @ApiModelProperty("完整标题")
    private String fullHead;

    /**
     * 关键字
     */
    @ApiModelProperty("关键字")
    private String keyword;

    /**
     * 当前用户id
     */
    @ApiModelProperty(value = "当前用户id", hidden = true)
    private Long loginId;

}
