package com.xjrsoft.module.room.mapper;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.github.yulichang.base.MPJBaseMapper;
import com.xjrsoft.module.room.dto.AddRoomDto;
import com.xjrsoft.module.room.dto.RoomPageDto;
import com.xjrsoft.module.room.entity.Room;
import com.xjrsoft.module.room.vo.RoomClassCountVo;
import com.xjrsoft.module.room.vo.RoomPageVo;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;

/**
* @title: 寝室
* @Author dzx
* @Date: 2023-12-27
* @Version 1.0
*/
@Mapper
public interface RoomMapper extends MPJBaseMapper<Room> {
    /**
     * 分页查询
     * @param page
     * @param dto
     * @return
     */
    Page<RoomPageVo> getPage(Page<RoomPageDto> page, RoomPageDto dto);


    /**
     * 批量添加
     */
    Boolean saveBatch(AddRoomDto dto);

    /**
     * 返回最大的序号
     * @return
     */
    Integer getMaxSortCode();

    List<RoomClassCountVo> getRoomClassCount(List<Long> ids);
}
