package com.xjrsoft.module.room.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.yulichang.base.MPJBaseServiceImpl;
import com.xjrsoft.module.room.dto.RoomBedCheckRecordPageDto;
import com.xjrsoft.module.room.entity.RoomBedCheckRecord;
import com.xjrsoft.module.room.entity.RoomBedCheckRecordRelation;
import com.xjrsoft.module.room.mapper.RoomBedCheckRecordMapper;
import com.xjrsoft.module.room.mapper.RoomBedCheckRecordRelationMapper;
import com.xjrsoft.module.room.service.IRoomBedCheckRecordService;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Objects;
import java.util.stream.Collectors;

/**
* @title: 查寝记录
* @Author szs
* @Date: 2024-01-02
* @Version 1.0
*/
@Service
@AllArgsConstructor
public class RoomBedCheckRecordServiceImpl extends MPJBaseServiceImpl<RoomBedCheckRecordMapper, RoomBedCheckRecord> implements IRoomBedCheckRecordService {
    private final RoomBedCheckRecordMapper roomBedCheckRecordRoomBedCheckRecordMapper;

    private final RoomBedCheckRecordRelationMapper roomBedCheckRecordRoomBedCheckRecordRelationMapper;


    @Override
    @Transactional(rollbackFor = Exception.class)
    public Boolean add(RoomBedCheckRecord roomBedCheckRecord) {
        roomBedCheckRecordRoomBedCheckRecordMapper.insert(roomBedCheckRecord);
        for (RoomBedCheckRecordRelation roomBedCheckRecordRelation : roomBedCheckRecord.getRoomBedCheckRecordRelationList()) {
            roomBedCheckRecordRelation.setRoomBedCheckRecordId(roomBedCheckRecord.getId());
            roomBedCheckRecordRoomBedCheckRecordRelationMapper.insert(roomBedCheckRecordRelation);
        }

        return true;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Boolean update(RoomBedCheckRecord roomBedCheckRecord) {
        roomBedCheckRecordRoomBedCheckRecordMapper.updateById(roomBedCheckRecord);
        //********************************* RoomBedCheckRecordRelation  增删改  开始 *******************************************/
        {
            // 查出所有子级的id
            List<RoomBedCheckRecordRelation> roomBedCheckRecordRelationList = roomBedCheckRecordRoomBedCheckRecordRelationMapper.selectList(Wrappers.lambdaQuery(RoomBedCheckRecordRelation.class).eq(RoomBedCheckRecordRelation::getRoomBedCheckRecordId, roomBedCheckRecord.getId()).select(RoomBedCheckRecordRelation::getId));
            List<Long> roomBedCheckRecordRelationIds = roomBedCheckRecordRelationList.stream().map(RoomBedCheckRecordRelation::getId).collect(Collectors.toList());
            //原有子表单 没有被删除的主键
            List<Long> roomBedCheckRecordRelationOldIds = roomBedCheckRecord.getRoomBedCheckRecordRelationList().stream().map(RoomBedCheckRecordRelation::getId).filter(Objects::nonNull).collect(Collectors.toList());
            //找到需要删除的id
            List<Long> roomBedCheckRecordRelationRemoveIds = roomBedCheckRecordRelationIds.stream().filter(item -> !roomBedCheckRecordRelationOldIds.contains(item)).collect(Collectors.toList());

            for (RoomBedCheckRecordRelation roomBedCheckRecordRelation : roomBedCheckRecord.getRoomBedCheckRecordRelationList()) {
                //如果不等于空则修改
                if (roomBedCheckRecordRelation.getId() != null) {
                    roomBedCheckRecordRoomBedCheckRecordRelationMapper.updateById(roomBedCheckRecordRelation);
                }
                //如果等于空 则新增
                else {
                    //已经不存在的id 删除
                    roomBedCheckRecordRelation.setRoomBedCheckRecordId(roomBedCheckRecord.getId());
                    roomBedCheckRecordRoomBedCheckRecordRelationMapper.insert(roomBedCheckRecordRelation);
                }
            }
            //已经不存在的id 删除
            if(roomBedCheckRecordRelationRemoveIds.size() > 0){
                roomBedCheckRecordRoomBedCheckRecordRelationMapper.deleteBatchIds(roomBedCheckRecordRelationRemoveIds);
            }
        }
        //********************************* RoomBedCheckRecordRelation  增删改  结束 *******************************************/

        return true;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Boolean delete(List<Long> ids) {
        roomBedCheckRecordRoomBedCheckRecordMapper.deleteBatchIds(ids);
        roomBedCheckRecordRoomBedCheckRecordRelationMapper.delete(Wrappers.lambdaQuery(RoomBedCheckRecordRelation.class).in(RoomBedCheckRecordRelation::getRoomBedCheckRecordId, ids));

        return true;
    }

    @Override
    public IPage<RoomBedCheckRecord> getPage(RoomBedCheckRecordPageDto dto) {
        //查询当前用户的班级
//        LambdaQueryWrapper<BaseClass> queryWrapper = new LambdaQueryWrapper<>();
//        queryWrapper
//                .eq(BaseClass::getTeacherId, StpUtil.getLoginIdAsLong())
//                .orderByDesc(BaseClass::getId);
//        BaseClass
//
//        MPJLambdaWrapper<RoomBedCheckRecord> query = new MPJLambdaWrapper<>();
//
//        LambdaQueryWrapper<RoomBedCheckRecord> queryWrapper = new LambdaQueryWrapper<>();
//        queryWrapper
//                .orderByDesc(RoomBedCheckRecord::getId)
//                .select(RoomBedCheckRecord.class,x -> VoToColumnUtil.fieldsToColumns(RoomBedCheckRecordPageVo.class).contains(x.getProperty()));
        //IPage<RoomBedCheckRecord> page = this.getPage(ConventPage.getPage(dto), queryWrapper);
        return null;
    }
}
