package com.xjrsoft.module.student.service.impl;

import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.github.yulichang.base.MPJBaseServiceImpl;
import com.xjrsoft.module.student.dto.StudentHonorsPageDto;
import com.xjrsoft.module.student.entity.StudentHonors;
import com.xjrsoft.module.student.mapper.StudentHonorsMapper;
import com.xjrsoft.module.student.service.IStudentHonorsService;
import com.xjrsoft.module.student.vo.StudentHonorsListVo;
import com.xjrsoft.module.student.vo.StudentHonorsPageVo;
import com.xjrsoft.module.student.vo.StudentHonorsVo;
import com.xjrsoft.module.system.entity.File;
import com.xjrsoft.module.system.service.IFileService;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;

import java.util.List;

/**
* @title: 学生荣誉
* @Author dzx
* @Date: 2023-12-05
* @Version 1.0
*/
@Service
@AllArgsConstructor
public class StudentHonorsServiceImpl extends MPJBaseServiceImpl<StudentHonorsMapper, StudentHonors> implements IStudentHonorsService {
    private final StudentHonorsMapper studentHonorsMapper;
    private final IFileService fileService;
    @Override
    public Page<StudentHonorsPageVo> getPage(Page<StudentHonorsPageDto> page, StudentHonorsPageDto dto) {
        return studentHonorsMapper.getPage(page, dto);
    }

    @Override
    public List<StudentHonorsListVo> getClassInfo() {
        return studentHonorsMapper.getClassInfo();
    }

    @Override
    public List<StudentHonorsListVo> getSemesterInfo() {
        return studentHonorsMapper.getSemesterInfo();
    }

    @Override
    public StudentHonorsVo getInfo(Long id) {
        StudentHonorsVo result = studentHonorsMapper.getInfo(id);
        if(ObjectUtil.isNotNull(result) && ObjectUtil.isNotNull(result.getFileId())){
            result.setFileInfos(fileService.list(Wrappers.<File>query().lambda().eq(File::getFolderId, result.getFileId())));
        }

        return result;
    }

    @Override
    public Integer getSortCode() {
        return studentHonorsMapper.getSortCode();
    }
}
