package com.xjrsoft.module.textbook.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import java.io.Serializable;
import com.fasterxml.jackson.annotation.JsonFormat;

import java.time.LocalTime;
import java.time.LocalDateTime;
import java.math.BigDecimal;
import java.util.List;
import java.util.Date;
import com.xjrsoft.module.textbook.entity.WfTextbookClaimItem;



/**
* @title: 教材申领
* @Author szs
* @Date: 2023-12-26
* @Version 1.0
*/
@Data
public class AddWfTextbookClaimDto implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
    * 序号
    */
    @ApiModelProperty("序号")
    private Integer sortCode;
    /**
    * 申请人
    */
    @ApiModelProperty("申请人")
    private Long applicantUserId;
    /**
    * 班级编号
    */
    @ApiModelProperty("班级编号")
    private Long classId;
    /**
    * 学期ID(base_semester)
    */
    @ApiModelProperty("学期ID(base_semester)")
    private Long baseSemesterId;
    /**
    * 学生编号
    */
    @ApiModelProperty("学生编号")
    private Long studentUserId;
    /**
    * 领取地点
    */
    @ApiModelProperty("领取地点")
    private String claimAddress;
    /**
    * 申领类型(xjr_dictionary_item[claim_type])
    */
    @ApiModelProperty("申领类型(xjr_dictionary_item[claim_type])")
    private String claimType;
    /**
    * 代领取人
    */
    @ApiModelProperty("代领取人")
    private String receiveUserId;
    /**
    * 领取用户编号（申请人帮领取人申请去领取）
    */
    @ApiModelProperty("领取用户编号（申请人帮领取人申请去领取）")
    private Long claimUserId;
    /**
    * 状态（1:结束 0:未结束）
    */
    @ApiModelProperty("状态（1:结束 0:未结束）")
    private Integer status;

    /**
    * wfTextbookClaimItem
    */
    @ApiModelProperty("wfTextbookClaimItem子表")
    private List<AddWfTextbookClaimItemDto> wfTextbookClaimItemList;
}
